'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _rax = require('rax');

var _universalEnv = require('universal-env');

var _View = require('./View');

var _View2 = _interopRequireDefault(_View);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Image = (_temp = _class = function (_Component) {
  _inherits(Image, _Component);

  function Image() {
    _classCallCheck(this, Image);

    return _possibleConstructorReturn(this, (Image.__proto__ || Object.getPrototypeOf(Image)).apply(this, arguments));
  }

  _createClass(Image, [{
    key: 'render',
    value: function render() {
      var nativeProps = _extends({}, this.props);
      var source = nativeProps.source;

      // Source must a object
      if (source && source.uri) {
        var style = nativeProps.style;
        var width = source.width,
            height = source.height,
            uri = source.uri;

        // Default is 0

        if (width == null && height == null && style.height == null && style.width == null) {
          width = 0;
          height = 0;
        }

        nativeProps.style = _extends({
          display: 'flex',
          width: width,
          height: height
        }, style);
        nativeProps.src = uri;

        delete nativeProps.source;

        var NativeImage = void 0;
        if (_universalEnv.isWeex) {
          NativeImage = 'image';
        } else {
          NativeImage = 'img';
        }

        // for cover and contain
        var resizeMode = nativeProps.resizeMode || nativeProps.style.resizeMode;
        if (resizeMode) {
          if (_universalEnv.isWeex) {
            nativeProps.resize = resizeMode;
            nativeProps.style.resizeMode = resizeMode;
          } else {
            nativeProps.style.objectFit = resizeMode;
          }
        }

        if (this.props.children) {
          nativeProps.children = null;
          return (0, _rax.createElement)(
            _View2.default,
            { style: nativeProps.style },
            (0, _rax.createElement)(NativeImage, nativeProps),
            (0, _rax.createElement)(
              _View2.default,
              { style: styles.absoluteImage },
              this.props.children
            )
          );
        } else {
          return (0, _rax.createElement)(NativeImage, nativeProps);
        }
      }
      return null;
    }
  }]);

  return Image;
}(_rax.Component), _class.resizeMode = {
  contain: 'contain',
  cover: 'cover',
  stretch: 'stretch',
  center: 'center',
  repeat: 'repeat'
}, _temp);


var styles = {
  absoluteImage: {
    left: 0,
    top: 0,
    position: 'absolute'
  }
};

exports.default = Image;