'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _rax = require('rax');

var _universalEnv = require('universal-env');

var _Text = require('./Text');

var _Text2 = _interopRequireDefault(_Text);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Link = (_temp = _class = function (_Component) {
  _inherits(Link, _Component);

  function Link() {
    _classCallCheck(this, Link);

    return _possibleConstructorReturn(this, (Link.__proto__ || Object.getPrototypeOf(Link)).apply(this, arguments));
  }

  _createClass(Link, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        isInAParentLink: true
      };
    }
  }, {
    key: 'render',
    value: function render() {
      // https://www.w3.org/TR/html4/struct/links.html#h-12.2.2
      if (this.context.isInAParentLink) {
        return console.error('Nested links are illegal');
      }

      var props = this.props;
      var children = props.children;
      var nativeProps = _extends({}, props);

      if (nativeProps.onPress) {
        nativeProps.onClick = nativeProps.onPress;
        delete nativeProps.onPress;
      }

      var content = children;
      if (typeof children === 'string') {
        content = (0, _rax.createElement)(
          _Text2.default,
          null,
          children
        );
      }

      if (_universalEnv.isWeex) {
        return (0, _rax.createElement)(
          'a',
          nativeProps,
          content
        );
      } else {
        var style = _extends({}, styles.initial, nativeProps.style);

        return (0, _rax.createElement)(
          'a',
          _extends({}, nativeProps, { style: style }),
          content
        );
      }
    }
  }]);

  return Link;
}(_rax.Component), _class.contextTypes = {
  isInAParentLink: _rax.PropTypes.bool
}, _class.childContextTypes = {
  isInAParentLink: _rax.PropTypes.bool
}, _temp);


var styles = {
  initial: {
    textDecoration: 'none'
  }
};

exports.default = Link;